diff --git a/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleAutoConfiguration.java b/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleAutoConfiguration.java
new file mode 100644
index 00000000000..25ab4266a73
--- /dev/null
+++ b/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleAutoConfiguration.java
@@ -0,0 +1,56 @@
+/*
+ * Copyright 2012-2015 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package org.springframework.boot.autoconfigure.test;
+
+import javax.management.MalformedObjectNameException;
+
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.boot.autoconfigure.AutoConfigureAfter;
+import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
+import org.springframework.boot.autoconfigure.jmx.JmxAutoConfiguration;
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Configuration;
+import org.springframework.jmx.export.MBeanExporter;
+
+/**
+ * Register a JMX component that allows to manage the lifecycle of the current
+ * application. Intended for internal use only.
+ *
+ * @author Stephane Nicoll
+ * @since 1.3.0
+ * @see SpringApplicationLifecycleMXBean
+ */
+@Configuration
+@AutoConfigureAfter(JmxAutoConfiguration.class)
+@ConditionalOnProperty(value = "spring.application.lifecycle.enabled", havingValue = "true", matchIfMissing = false)
+class SpringApplicationLifecycleAutoConfiguration {
+
+	static final String OBJECT_NAME = "org.springframework.boot.test:type=SpringApplicationLifecycle";
+
+	@Autowired(required = false)
+	private MBeanExporter mbeanExporter;
+
+	@Bean
+	public SpringApplicationLifecycleRegistrar applicationHookPointHandler() throws MalformedObjectNameException {
+		String jmxName = OBJECT_NAME;
+		if (mbeanExporter != null) { // Make sure to not register that MBean twice
+			mbeanExporter.addExcludedBean(jmxName);
+		}
+		return new SpringApplicationLifecycleRegistrar(jmxName);
+	}
+
+}
diff --git a/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleMXBean.java b/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleMXBean.java
new file mode 100644
index 00000000000..d624e6f4cd5
--- /dev/null
+++ b/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleMXBean.java
@@ -0,0 +1,39 @@
+/*
+ * Copyright 2012-2015 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package org.springframework.boot.autoconfigure.test;
+
+/**
+ * A simple MBean contract to controle the lifecycle of a {@code SpringApplication} via
+ * JMX. Intended for internal use only.
+ *
+ * @author Stephane Nicoll
+ * @since 1.3.0
+ */
+public interface SpringApplicationLifecycleMXBean {
+
+	/**
+	 * Specify if the application has fully started and is now ready.
+	 */
+	boolean isReady();
+
+	/**
+	 * Shutdown the application.
+	 * @see org.springframework.context.ConfigurableApplicationContext#close()
+	 */
+	void shutdown();
+
+}
diff --git a/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleRegistrar.java b/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleRegistrar.java
new file mode 100644
index 00000000000..9c9a4622116
--- /dev/null
+++ b/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleRegistrar.java
@@ -0,0 +1,100 @@
+/*
+ * Copyright 2012-2015 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package org.springframework.boot.autoconfigure.test;
+
+import java.lang.management.ManagementFactory;
+import javax.management.MBeanServer;
+import javax.management.MalformedObjectNameException;
+import javax.management.ObjectName;
+
+import org.apache.commons.logging.Log;
+import org.apache.commons.logging.LogFactory;
+
+import org.springframework.beans.BeansException;
+import org.springframework.beans.factory.DisposableBean;
+import org.springframework.beans.factory.InitializingBean;
+import org.springframework.boot.context.event.ApplicationStartedEvent;
+import org.springframework.context.ApplicationContext;
+import org.springframework.context.ApplicationContextAware;
+import org.springframework.context.ApplicationListener;
+import org.springframework.context.ConfigurableApplicationContext;
+import org.springframework.util.Assert;
+
+/**
+ * Register a {@link SpringApplicationLifecycleMXBean} implementation so that it is only exposed
+ * to JMX.
+ *
+ * @author Stephane Nicoll
+ * @since 1.3.0
+ */
+class SpringApplicationLifecycleRegistrar implements ApplicationContextAware, InitializingBean, DisposableBean,
+		ApplicationListener<ApplicationStartedEvent> {
+
+	private static final Log logger = LogFactory.getLog(SpringApplicationLifecycleRegistrar.class);
+
+	private ConfigurableApplicationContext applicationContext;
+
+	private final ObjectName objectName;
+
+	private boolean ready = false;
+
+	public SpringApplicationLifecycleRegistrar(String name) throws MalformedObjectNameException {
+		this.objectName = new ObjectName(name);
+	}
+
+	@Override
+	public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
+		Assert.isTrue(applicationContext instanceof ConfigurableApplicationContext,
+				"ApplicationContext does not implement ConfigurableApplicationContext");
+		this.applicationContext = (ConfigurableApplicationContext) applicationContext;
+	}
+
+	@Override
+	public void onApplicationEvent(ApplicationStartedEvent event) {
+		ready = true;
+	}
+
+	@Override
+	public void afterPropertiesSet() throws Exception {
+		MBeanServer server = ManagementFactory.getPlatformMBeanServer();
+		server.registerMBean(new SpringApplicationLifecycle(), objectName);
+		if (logger.isDebugEnabled()) {
+			logger.debug("Application shutdown registered with name '" + objectName + "'");
+		}
+	}
+
+	@Override
+	public void destroy() throws Exception {
+		ManagementFactory.getPlatformMBeanServer().unregisterMBean(objectName);
+	}
+
+	private class SpringApplicationLifecycle implements SpringApplicationLifecycleMXBean {
+
+		@Override
+		public boolean isReady() {
+			return ready;
+		}
+
+		@Override
+		public void shutdown() {
+			logger.info("Application shutdown requested.");
+			applicationContext.close();
+		}
+	}
+
+}
+
diff --git a/spring-boot-autoconfigure/src/main/resources/META-INF/spring.factories b/spring-boot-autoconfigure/src/main/resources/META-INF/spring.factories
index 2042b37de23..d7e3bc4aa69 100644
--- a/spring-boot-autoconfigure/src/main/resources/META-INF/spring.factories
+++ b/spring-boot-autoconfigure/src/main/resources/META-INF/spring.factories
@@ -57,6 +57,7 @@ org.springframework.boot.autoconfigure.social.LinkedInAutoConfiguration,\
 org.springframework.boot.autoconfigure.social.TwitterAutoConfiguration,\
 org.springframework.boot.autoconfigure.solr.SolrAutoConfiguration,\
 org.springframework.boot.autoconfigure.velocity.VelocityAutoConfiguration,\
+org.springframework.boot.autoconfigure.test.SpringApplicationLifecycleAutoConfiguration,\
 org.springframework.boot.autoconfigure.thymeleaf.ThymeleafAutoConfiguration,\
 org.springframework.boot.autoconfigure.web.DispatcherServletAutoConfiguration,\
 org.springframework.boot.autoconfigure.web.EmbeddedServletContainerAutoConfiguration,\
diff --git a/spring-boot-autoconfigure/src/test/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleAutoConfigurationTests.java b/spring-boot-autoconfigure/src/test/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleAutoConfigurationTests.java
new file mode 100644
index 00000000000..2e2300e4cc9
--- /dev/null
+++ b/spring-boot-autoconfigure/src/test/java/org/springframework/boot/autoconfigure/test/SpringApplicationLifecycleAutoConfigurationTests.java
@@ -0,0 +1,105 @@
+/*
+ * Copyright 2012-2015 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package org.springframework.boot.autoconfigure.test;
+
+import java.lang.management.ManagementFactory;
+import javax.management.InstanceNotFoundException;
+import javax.management.MBeanServer;
+import javax.management.MalformedObjectNameException;
+import javax.management.ObjectInstance;
+import javax.management.ObjectName;
+
+import org.junit.After;
+import org.junit.Rule;
+import org.junit.Test;
+import org.junit.rules.ExpectedException;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.jmx.JmxAutoConfiguration;
+import org.springframework.boot.context.event.ApplicationStartedEvent;
+import org.springframework.boot.test.EnvironmentTestUtils;
+import org.springframework.context.annotation.AnnotationConfigApplicationContext;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertTrue;
+
+/**
+ * Tests for {@link SpringApplicationLifecycleAutoConfiguration}.
+ *
+ * @author Stephane Nicoll
+ */
+public class SpringApplicationLifecycleAutoConfigurationTests {
+
+	@Rule
+	public final ExpectedException thrown = ExpectedException.none();
+
+	private AnnotationConfigApplicationContext context;
+
+	@After
+	public void tearDown() {
+		if (this.context != null) {
+			this.context.close();
+		}
+	}
+
+	@Test
+	public void notRegisteredByDefault() throws MalformedObjectNameException, InstanceNotFoundException {
+		load();
+		MBeanServer server = ManagementFactory.getPlatformMBeanServer();
+		ObjectName objectName = new ObjectName(SpringApplicationLifecycleAutoConfiguration.OBJECT_NAME);
+
+
+		thrown.expect(InstanceNotFoundException.class);
+		server.getObjectInstance(objectName);
+	}
+
+	@Test
+	public void registeredWithProperty() throws Exception {
+		load("spring.application.lifecycle.enabled=true");
+		MBeanServer server = ManagementFactory.getPlatformMBeanServer();
+		ObjectName objectName = new ObjectName(SpringApplicationLifecycleAutoConfiguration.OBJECT_NAME);
+
+		ObjectInstance objectInstance = server.getObjectInstance(objectName);
+		assertNotNull(objectInstance);
+
+		assertEquals("Simple context does not trigger proper event",
+				false, server.getAttribute(objectName, "Ready"));
+		this.context.publishEvent(new ApplicationStartedEvent(new SpringApplication(), null));
+		assertEquals("Application should be ready",
+				true, server.getAttribute(objectName, "Ready"));
+
+		assertTrue("context has been started", this.context.isActive());
+		server.invoke(objectName, "shutdown", null, null);
+		assertFalse("Context should have been closed", this.context.isActive());
+
+		thrown.expect(InstanceNotFoundException.class); // JMX cleanup
+		server.getObjectInstance(objectName);
+	}
+
+
+	private void load(String... environment) {
+		AnnotationConfigApplicationContext applicationContext = new AnnotationConfigApplicationContext();
+		EnvironmentTestUtils.addEnvironment(applicationContext, environment);
+		applicationContext.register(JmxAutoConfiguration.class, SpringApplicationLifecycleAutoConfiguration.class);
+		applicationContext.refresh();
+		this.context = applicationContext;
+	}
+
+}
+
diff --git a/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/AbstractRunMojo.java b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/AbstractRunMojo.java
new file mode 100644
index 00000000000..b78241c40f9
--- /dev/null
+++ b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/AbstractRunMojo.java
@@ -0,0 +1,385 @@
+/*
+ * Copyright 2012-2014 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package org.springframework.boot.maven;
+
+import java.io.File;
+import java.io.IOException;
+import java.lang.reflect.Method;
+import java.net.MalformedURLException;
+import java.net.URL;
+import java.security.CodeSource;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.List;
+import java.util.Set;
+
+import org.apache.maven.artifact.Artifact;
+import org.apache.maven.model.Resource;
+import org.apache.maven.plugin.MojoExecutionException;
+import org.apache.maven.plugin.MojoFailureException;
+import org.apache.maven.plugins.annotations.Parameter;
+import org.apache.maven.project.MavenProject;
+import org.apache.maven.shared.artifact.filter.collection.AbstractArtifactFeatureFilter;
+import org.apache.maven.shared.artifact.filter.collection.FilterArtifacts;
+
+import org.springframework.boot.loader.tools.FileUtils;
+import org.springframework.boot.loader.tools.MainClassFinder;
+
+/**
+ * Run an executable archive application.
+ *
+ * @author Phillip Webb
+ * @author Stephane Nicoll
+ * @author David Liu
+ */
+public abstract class AbstractRunMojo extends AbstractDependencyFilterMojo {
+
+	private static final String SPRING_LOADED_AGENT_CLASSNAME = "org.springsource.loaded.agent.SpringLoadedAgent";
+
+	/**
+	 * The Maven project.
+	 * @since 1.0
+	 */
+	@Parameter(defaultValue = "${project}", readonly = true, required = true)
+	private MavenProject project;
+
+	/**
+	 * Add maven resources to the classpath directly, this allows live in-place editing of
+	 * resources. Duplicate resources are removed from {@code target/classes} to prevent
+	 * them to appear twice if {@code ClassLoader.getResources()} is called.
+	 * @since 1.0
+	 */
+	@Parameter(property = "run.addResources", defaultValue = "true")
+	private boolean addResources;
+
+	/**
+	 * Path to agent jar. NOTE: the use of agents means that processes will be started by
+	 * forking a new JVM.
+	 * @since 1.0
+	 */
+	@Parameter(property = "run.agent")
+	private File[] agent;
+
+	/**
+	 * Flag to say that the agent requires -noverify.
+	 * @since 1.0
+	 */
+	@Parameter(property = "run.noverify")
+	private Boolean noverify;
+
+	/**
+	 * JVM arguments that should be associated with the forked process used to run the
+	 * application. On command line, make sure to wrap multiple values between quotes.
+	 * @since 1.1
+	 */
+	@Parameter(property = "run.jvmArguments")
+	private String jvmArguments;
+
+	/**
+	 * Arguments that should be passed to the application. On command line use commas to
+	 * separate multiple arguments.
+	 * @since 1.0
+	 */
+	@Parameter(property = "run.arguments")
+	private String[] arguments;
+
+	/**
+	 * The name of the main class. If not specified the first compiled class found that
+	 * contains a 'main' method will be used.
+	 * @since 1.0
+	 */
+	@Parameter
+	private String mainClass;
+
+	/**
+	 * Additional folders besides the classes directory that should be added to the
+	 * classpath.
+	 * @since 1.0
+	 */
+	@Parameter
+	private String[] folders;
+
+	/**
+	 * Directory containing the classes and resource files that should be packaged into
+	 * the archive.
+	 * @since 1.0
+	 */
+	@Parameter(defaultValue = "${project.build.outputDirectory}", required = true)
+	private File classesDirectory;
+
+	/**
+	 * Flag to indicate if the run processes should be forked. By default process forking
+	 * is only used if an agent or jvmArguments are specified.
+	 * @since 1.2
+	 */
+	@Parameter(property = "fork")
+	private Boolean fork;
+
+	@Override
+	public void execute() throws MojoExecutionException, MojoFailureException {
+		final String startClassName = getStartClass();
+		run(startClassName);
+	}
+
+	private void findAgent() {
+		try {
+			if (this.agent == null || this.agent.length == 0) {
+				Class<?> loaded = Class.forName(SPRING_LOADED_AGENT_CLASSNAME);
+				if (loaded != null) {
+					if (this.noverify == null) {
+						this.noverify = true;
+					}
+					CodeSource source = loaded.getProtectionDomain().getCodeSource();
+					if (source != null) {
+						this.agent = new File[] {new File(source.getLocation().getFile())};
+					}
+				}
+			}
+		}
+		catch (ClassNotFoundException ex) {
+			// ignore;
+		}
+		if (this.noverify == null) {
+			this.noverify = false;
+		}
+	}
+
+	private void run(String startClassName) throws MojoExecutionException {
+		findAgent();
+		boolean hasAgent = (this.agent != null && this.agent.length > 0);
+		boolean hasJvmArgs = (this.jvmArguments != null && this.jvmArguments.length() > 0);
+		if (Boolean.TRUE.equals(this.fork)
+				|| (this.fork == null && (hasAgent || hasJvmArgs))) {
+			runWithForkedJvm(startClassName);
+		}
+		else {
+			if (hasAgent) {
+				getLog().warn("Fork mode disabled, ignoring agent");
+			}
+			if (hasJvmArgs) {
+				getLog().warn(
+						"Fork mode disabled, ignoring JVM argument(s) ["
+								+ this.jvmArguments + "]");
+			}
+			runWithMavenJvm(startClassName, this.arguments);
+		}
+	}
+
+	protected abstract void runWithForkedJvm(String startClassName) throws MojoExecutionException;
+
+
+	protected abstract void runWithMavenJvm(String startClassName, String... arguments) throws MojoExecutionException;
+
+	protected void addAgents(List<String> args) {
+		if (this.agent != null) {
+			getLog().info("Attaching agents: " + Arrays.asList(this.agent));
+			for (File agent : this.agent) {
+				args.add("-javaagent:" + agent);
+			}
+		}
+		if (this.noverify) {
+			args.add("-noverify");
+		}
+	}
+
+	protected void addJvmArgs(List<String> args) {
+		RunArguments jvmArguments = new RunArguments(this.jvmArguments);
+		Collections.addAll(args, jvmArguments.asArray());
+		logArguments("JVM argument(s): ", jvmArguments.asArray());
+	}
+
+	protected void addClasspath(List<String> args) throws MojoExecutionException {
+		try {
+			StringBuilder classpath = new StringBuilder();
+			for (URL ele : getClassPathUrls()) {
+				classpath = classpath.append((classpath.length() > 0 ? File.pathSeparator
+						: "") + new File(ele.toURI()));
+			}
+			getLog().debug("Classpath for forked process: " + classpath);
+			args.add("-cp");
+			args.add(classpath.toString());
+		}
+		catch (Exception e) {
+			throw new MojoExecutionException("Could not build classpath", e);
+		}
+	}
+
+	protected void addArgs(List<String> args) {
+		Collections.addAll(args, this.arguments);
+		logArguments("Application argument(s): ", this.arguments);
+	}
+
+	private final String getStartClass() throws MojoExecutionException {
+		String mainClass = this.mainClass;
+		if (mainClass == null) {
+			try {
+				mainClass = MainClassFinder.findSingleMainClass(this.classesDirectory);
+			}
+			catch (IOException ex) {
+				throw new MojoExecutionException(ex.getMessage(), ex);
+			}
+		}
+		if (mainClass == null) {
+			throw new MojoExecutionException("Unable to find a suitable main class, "
+					+ "please add a 'mainClass' property");
+		}
+		return mainClass;
+	}
+
+	protected URL[] getClassPathUrls() throws MojoExecutionException {
+		try {
+			List<URL> urls = new ArrayList<URL>();
+			addUserDefinedFolders(urls);
+			addResources(urls);
+			addProjectClasses(urls);
+			addDependencies(urls);
+			return urls.toArray(new URL[urls.size()]);
+		}
+		catch (MalformedURLException ex) {
+			throw new MojoExecutionException("Unable to build classpath", ex);
+		}
+		catch (IOException ex) {
+			throw new MojoExecutionException("Unable to build classpath", ex);
+		}
+	}
+
+	private void addUserDefinedFolders(List<URL> urls) throws MalformedURLException {
+		if (this.folders != null) {
+			for (String folder : this.folders) {
+				urls.add(new File(folder).toURI().toURL());
+			}
+		}
+	}
+
+	private void addResources(List<URL> urls) throws IOException {
+		if (this.addResources) {
+			for (Resource resource : this.project.getResources()) {
+				File directory = new File(resource.getDirectory());
+				urls.add(directory.toURI().toURL());
+				FileUtils.removeDuplicatesFromOutputDirectory(this.classesDirectory,
+						directory);
+			}
+		}
+	}
+
+	private void addProjectClasses(List<URL> urls) throws MalformedURLException {
+		urls.add(this.classesDirectory.toURI().toURL());
+	}
+
+	private void addDependencies(List<URL> urls) throws MalformedURLException,
+			MojoExecutionException {
+		FilterArtifacts filters = getFilters(new TestArtifactFilter());
+		Set<Artifact> artifacts = filterDependencies(this.project.getArtifacts(), filters);
+		for (Artifact artifact : artifacts) {
+			if (artifact.getFile() != null) {
+				urls.add(artifact.getFile().toURI().toURL());
+			}
+		}
+	}
+
+	private void logArguments(String message, String[] args) {
+		StringBuffer sb = new StringBuffer(message);
+		for (String arg : args) {
+			sb.append(arg).append(" ");
+		}
+		getLog().debug(sb.toString().trim());
+	}
+
+
+	private static class TestArtifactFilter extends AbstractArtifactFeatureFilter {
+		public TestArtifactFilter() {
+			super("", Artifact.SCOPE_TEST);
+		}
+
+		@Override
+		protected String getArtifactFeature(Artifact artifact) {
+			return artifact.getScope();
+		}
+	}
+
+	/**
+	 * Isolated {@link ThreadGroup} to capture uncaught exceptions.
+	 */
+	class IsolatedThreadGroup extends ThreadGroup {
+
+		private Throwable exception;
+
+		public IsolatedThreadGroup(String name) {
+			super(name);
+		}
+
+		@Override
+		public void uncaughtException(Thread thread, Throwable ex) {
+			if (!(ex instanceof ThreadDeath)) {
+				synchronized (this) {
+					this.exception = (this.exception == null ? ex : this.exception);
+				}
+				getLog().warn(ex);
+			}
+		}
+
+		public synchronized void rethrowUncaughtException() throws MojoExecutionException {
+			if (this.exception != null) {
+				throw new MojoExecutionException("An exception occured while running. "
+						+ this.exception.getMessage(), this.exception);
+			}
+		}
+
+	}
+
+	/**
+	 * Runner used to launch the application.
+	 */
+	class LaunchRunner implements Runnable {
+
+		private final String startClassName;
+
+		private final String[] args;
+
+		public LaunchRunner(String startClassName, String... args) {
+			this.startClassName = startClassName;
+			this.args = (args != null ? args : new String[] {});
+		}
+
+		@Override
+		public void run() {
+			Thread thread = Thread.currentThread();
+			ClassLoader classLoader = thread.getContextClassLoader();
+			try {
+				Class<?> startClass = classLoader.loadClass(this.startClassName);
+				Method mainMethod = startClass.getMethod("main",
+						new Class[] {String[].class});
+				if (!mainMethod.isAccessible()) {
+					mainMethod.setAccessible(true);
+				}
+				mainMethod.invoke(null, new Object[] {this.args});
+			}
+			catch (NoSuchMethodException ex) {
+				Exception wrappedEx = new Exception(
+						"The specified mainClass doesn't contain a "
+								+ "main method with appropriate signature.", ex);
+				thread.getThreadGroup().uncaughtException(thread, wrappedEx);
+			}
+			catch (Exception ex) {
+				thread.getThreadGroup().uncaughtException(thread, ex);
+			}
+		}
+
+	}
+
+}
diff --git a/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/RunArguments.java b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/RunArguments.java
index dfcfe97149a..4fd1396af07 100644
--- a/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/RunArguments.java
+++ b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/RunArguments.java
@@ -19,7 +19,7 @@
 import org.codehaus.plexus.util.cli.CommandLineUtils;
 
 /**
- * Parse and expose arguments specified as {@link RunMojo} parameters.
+ * Parse and expose arguments specified as {@link AbstractRunMojo} parameters.
  *
  * @author Stephane Nicoll
  * @since 1.1.0
diff --git a/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/RunMojo.java b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/RunMojo.java
index 684b962894f..51aaced4179 100644
--- a/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/RunMojo.java
+++ b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/RunMojo.java
@@ -1,5 +1,5 @@
 /*
- * Copyright 2012-2014 the original author or authors.
+ * Copyright 2012-2015 the original author or authors.
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
@@ -16,179 +16,28 @@
 
 package org.springframework.boot.maven;
 
-import java.io.File;
-import java.io.IOException;
-import java.lang.reflect.Method;
-import java.net.MalformedURLException;
-import java.net.URL;
 import java.net.URLClassLoader;
-import java.security.CodeSource;
 import java.util.ArrayList;
-import java.util.Arrays;
-import java.util.Collections;
 import java.util.List;
-import java.util.Set;
 
-import org.apache.maven.artifact.Artifact;
-import org.apache.maven.model.Resource;
 import org.apache.maven.plugin.MojoExecutionException;
-import org.apache.maven.plugin.MojoFailureException;
 import org.apache.maven.plugins.annotations.Execute;
 import org.apache.maven.plugins.annotations.LifecyclePhase;
 import org.apache.maven.plugins.annotations.Mojo;
-import org.apache.maven.plugins.annotations.Parameter;
 import org.apache.maven.plugins.annotations.ResolutionScope;
-import org.apache.maven.project.MavenProject;
-import org.apache.maven.shared.artifact.filter.collection.AbstractArtifactFeatureFilter;
-import org.apache.maven.shared.artifact.filter.collection.FilterArtifacts;
-import org.springframework.boot.loader.tools.FileUtils;
+
 import org.springframework.boot.loader.tools.JavaExecutable;
-import org.springframework.boot.loader.tools.MainClassFinder;
 import org.springframework.boot.loader.tools.RunProcess;
 
 /**
- * Run an executable archive application.
  *
- * @author Phillip Webb
  * @author Stephane Nicoll
- * @author David Liu
  */
 @Mojo(name = "run", requiresProject = true, defaultPhase = LifecyclePhase.VALIDATE, requiresDependencyResolution = ResolutionScope.TEST)
 @Execute(phase = LifecyclePhase.TEST_COMPILE)
-public class RunMojo extends AbstractDependencyFilterMojo {
-
-	private static final String SPRING_LOADED_AGENT_CLASSNAME = "org.springsource.loaded.agent.SpringLoadedAgent";
-
-	/**
-	 * The Maven project.
-	 * @since 1.0
-	 */
-	@Parameter(defaultValue = "${project}", readonly = true, required = true)
-	private MavenProject project;
-
-	/**
-	 * Add maven resources to the classpath directly, this allows live in-place editing of
-	 * resources. Duplicate resources are removed from {@code target/classes} to prevent
-	 * them to appear twice if {@code ClassLoader.getResources()} is called.
-	 * @since 1.0
-	 */
-	@Parameter(property = "run.addResources", defaultValue = "true")
-	private boolean addResources;
-
-	/**
-	 * Path to agent jar. NOTE: the use of agents means that processes will be started by
-	 * forking a new JVM.
-	 * @since 1.0
-	 */
-	@Parameter(property = "run.agent")
-	private File[] agent;
-
-	/**
-	 * Flag to say that the agent requires -noverify.
-	 * @since 1.0
-	 */
-	@Parameter(property = "run.noverify")
-	private Boolean noverify;
-
-	/**
-	 * JVM arguments that should be associated with the forked process used to run the
-	 * application. On command line, make sure to wrap multiple values between quotes.
-	 * @since 1.1
-	 */
-	@Parameter(property = "run.jvmArguments")
-	private String jvmArguments;
-
-	/**
-	 * Arguments that should be passed to the application. On command line use commas to
-	 * separate multiple arguments.
-	 * @since 1.0
-	 */
-	@Parameter(property = "run.arguments")
-	private String[] arguments;
-
-	/**
-	 * The name of the main class. If not specified the first compiled class found that
-	 * contains a 'main' method will be used.
-	 * @since 1.0
-	 */
-	@Parameter
-	private String mainClass;
-
-	/**
-	 * Additional folders besides the classes directory that should be added to the
-	 * classpath.
-	 * @since 1.0
-	 */
-	@Parameter
-	private String[] folders;
-
-	/**
-	 * Directory containing the classes and resource files that should be packaged into
-	 * the archive.
-	 * @since 1.0
-	 */
-	@Parameter(defaultValue = "${project.build.outputDirectory}", required = true)
-	private File classesDirectory;
-
-	/**
-	 * Flag to indicate if the run processes should be forked. By default process forking
-	 * is only used if an agent or jvmArguments are specified.
-	 * @since 1.2
-	 */
-	@Parameter(property = "fork")
-	private Boolean fork;
-
-	@Override
-	public void execute() throws MojoExecutionException, MojoFailureException {
-		final String startClassName = getStartClass();
-		run(startClassName);
-	}
+public class RunMojo extends AbstractRunMojo {
 
-	private void findAgent() {
-		try {
-			if (this.agent == null || this.agent.length == 0) {
-				Class<?> loaded = Class.forName(SPRING_LOADED_AGENT_CLASSNAME);
-				if (loaded != null) {
-					if (this.noverify == null) {
-						this.noverify = true;
-					}
-					CodeSource source = loaded.getProtectionDomain().getCodeSource();
-					if (source != null) {
-						this.agent = new File[] { new File(source.getLocation().getFile()) };
-					}
-				}
-			}
-		}
-		catch (ClassNotFoundException ex) {
-			// ignore;
-		}
-		if (this.noverify == null) {
-			this.noverify = false;
-		}
-	}
-
-	private void run(String startClassName) throws MojoExecutionException {
-		findAgent();
-		boolean hasAgent = (this.agent != null && this.agent.length > 0);
-		boolean hasJvmArgs = (this.jvmArguments != null && this.jvmArguments.length() > 0);
-		if (Boolean.TRUE.equals(this.fork)
-				|| (this.fork == null && (hasAgent || hasJvmArgs))) {
-			runWithForkedJvm(startClassName);
-		}
-		else {
-			if (hasAgent) {
-				getLog().warn("Fork mode disabled, ignoring agent");
-			}
-			if (hasJvmArgs) {
-				getLog().warn(
-						"Fork mode disabled, ignoring JVM argument(s) ["
-								+ this.jvmArguments + "]");
-			}
-			runWithMavenJvm(startClassName);
-		}
-	}
-
-	private void runWithForkedJvm(String startClassName) throws MojoExecutionException {
+	protected void runWithForkedJvm(String startClassName) throws MojoExecutionException {
 		List<String> args = new ArrayList<String>();
 		addAgents(args);
 		addJvmArgs(args);
@@ -204,132 +53,17 @@ private void runWithForkedJvm(String startClassName) throws MojoExecutionExcepti
 		}
 	}
 
-	private void runWithMavenJvm(String startClassName) throws MojoExecutionException {
+	protected void runWithMavenJvm(String startClassName, String... arguments) throws MojoExecutionException {
 		IsolatedThreadGroup threadGroup = new IsolatedThreadGroup(startClassName);
 		Thread launchThread = new Thread(threadGroup, new LaunchRunner(startClassName,
-				this.arguments), startClassName + ".main()");
+				arguments), startClassName + ".main()");
 		launchThread.setContextClassLoader(new URLClassLoader(getClassPathUrls()));
 		launchThread.start();
 		join(threadGroup);
 		threadGroup.rethrowUncaughtException();
 	}
 
-	private void addAgents(List<String> args) {
-		if (this.agent != null) {
-			getLog().info("Attaching agents: " + Arrays.asList(this.agent));
-			for (File agent : this.agent) {
-				args.add("-javaagent:" + agent);
-			}
-		}
-		if (this.noverify) {
-			args.add("-noverify");
-		}
-	}
-
-	private void addJvmArgs(List<String> args) {
-		RunArguments jvmArguments = new RunArguments(this.jvmArguments);
-		Collections.addAll(args, jvmArguments.asArray());
-		logArguments("JVM argument(s): ", jvmArguments.asArray());
-	}
-
-	private void addClasspath(List<String> args) throws MojoExecutionException {
-		try {
-			StringBuilder classpath = new StringBuilder();
-			for (URL ele : getClassPathUrls()) {
-				classpath = classpath.append((classpath.length() > 0 ? File.pathSeparator
-						: "") + new File(ele.toURI()));
-			}
-			getLog().debug("Classpath for forked process: " + classpath);
-			args.add("-cp");
-			args.add(classpath.toString());
-		}
-		catch (Exception e) {
-			throw new MojoExecutionException("Could not build classpath", e);
-		}
-	}
-
-	private void addArgs(List<String> args) {
-		Collections.addAll(args, this.arguments);
-		logArguments("Application argument(s): ", this.arguments);
-	}
-
-	private final String getStartClass() throws MojoExecutionException {
-		String mainClass = this.mainClass;
-		if (mainClass == null) {
-			try {
-				mainClass = MainClassFinder.findSingleMainClass(this.classesDirectory);
-			}
-			catch (IOException ex) {
-				throw new MojoExecutionException(ex.getMessage(), ex);
-			}
-		}
-		if (mainClass == null) {
-			throw new MojoExecutionException("Unable to find a suitable main class, "
-					+ "please add a 'mainClass' property");
-		}
-		return mainClass;
-	}
-
-	private URL[] getClassPathUrls() throws MojoExecutionException {
-		try {
-			List<URL> urls = new ArrayList<URL>();
-			addUserDefinedFolders(urls);
-			addResources(urls);
-			addProjectClasses(urls);
-			addDependencies(urls);
-			return urls.toArray(new URL[urls.size()]);
-		}
-		catch (MalformedURLException ex) {
-			throw new MojoExecutionException("Unable to build classpath", ex);
-		}
-		catch (IOException ex) {
-			throw new MojoExecutionException("Unable to build classpath", ex);
-		}
-	}
-
-	private void addUserDefinedFolders(List<URL> urls) throws MalformedURLException {
-		if (this.folders != null) {
-			for (String folder : this.folders) {
-				urls.add(new File(folder).toURI().toURL());
-			}
-		}
-	}
-
-	private void addResources(List<URL> urls) throws IOException {
-		if (this.addResources) {
-			for (Resource resource : this.project.getResources()) {
-				File directory = new File(resource.getDirectory());
-				urls.add(directory.toURI().toURL());
-				FileUtils.removeDuplicatesFromOutputDirectory(this.classesDirectory,
-						directory);
-			}
-		}
-	}
-
-	private void addProjectClasses(List<URL> urls) throws MalformedURLException {
-		urls.add(this.classesDirectory.toURI().toURL());
-	}
-
-	private void addDependencies(List<URL> urls) throws MalformedURLException,
-			MojoExecutionException {
-		FilterArtifacts filters = getFilters(new TestArtifactFilter());
-		Set<Artifact> artifacts = filterDependencies(this.project.getArtifacts(), filters);
-		for (Artifact artifact : artifacts) {
-			if (artifact.getFile() != null) {
-				urls.add(artifact.getFile().toURI().toURL());
-			}
-		}
-	}
-
-	private void logArguments(String message, String[] args) {
-		StringBuffer sb = new StringBuffer(message);
-		for (String arg : args) {
-			sb.append(arg).append(" ");
-		}
-		getLog().debug(sb.toString().trim());
-	}
-
-	private void join(ThreadGroup threadGroup) {
+	protected void join(ThreadGroup threadGroup) {
 		boolean hasNonDaemonThreads;
 		do {
 			hasNonDaemonThreads = false;
@@ -349,85 +83,4 @@ private void join(ThreadGroup threadGroup) {
 		}
 		while (hasNonDaemonThreads);
 	}
-
-	private static class TestArtifactFilter extends AbstractArtifactFeatureFilter {
-		public TestArtifactFilter() {
-			super("", Artifact.SCOPE_TEST);
-		}
-
-		@Override
-		protected String getArtifactFeature(Artifact artifact) {
-			return artifact.getScope();
-		}
-	}
-
-	/**
-	 * Isolated {@link ThreadGroup} to capture uncaught exceptions.
-	 */
-	class IsolatedThreadGroup extends ThreadGroup {
-
-		private Throwable exception;
-
-		public IsolatedThreadGroup(String name) {
-			super(name);
-		}
-
-		@Override
-		public void uncaughtException(Thread thread, Throwable ex) {
-			if (!(ex instanceof ThreadDeath)) {
-				synchronized (this) {
-					this.exception = (this.exception == null ? ex : this.exception);
-				}
-				getLog().warn(ex);
-			}
-		}
-
-		public synchronized void rethrowUncaughtException() throws MojoExecutionException {
-			if (this.exception != null) {
-				throw new MojoExecutionException("An exception occured while running. "
-						+ this.exception.getMessage(), this.exception);
-			}
-		}
-
-	}
-
-	/**
-	 * Runner used to launch the application.
-	 */
-	class LaunchRunner implements Runnable {
-
-		private final String startClassName;
-		private final String[] args;
-
-		public LaunchRunner(String startClassName, String... args) {
-			this.startClassName = startClassName;
-			this.args = (args != null ? args : new String[] {});
-		}
-
-		@Override
-		public void run() {
-			Thread thread = Thread.currentThread();
-			ClassLoader classLoader = thread.getContextClassLoader();
-			try {
-				Class<?> startClass = classLoader.loadClass(this.startClassName);
-				Method mainMethod = startClass.getMethod("main",
-						new Class[] { String[].class });
-				if (!mainMethod.isAccessible()) {
-					mainMethod.setAccessible(true);
-				}
-				mainMethod.invoke(null, new Object[] { this.args });
-			}
-			catch (NoSuchMethodException ex) {
-				Exception wrappedEx = new Exception(
-						"The specified mainClass doesn't contain a "
-								+ "main method with appropriate signature.", ex);
-				thread.getThreadGroup().uncaughtException(thread, wrappedEx);
-			}
-			catch (Exception ex) {
-				thread.getThreadGroup().uncaughtException(thread, ex);
-			}
-		}
-
-	}
-
 }
diff --git a/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/StartMojo.java b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/StartMojo.java
new file mode 100644
index 00000000000..125467c6550
--- /dev/null
+++ b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/StartMojo.java
@@ -0,0 +1,67 @@
+/*
+ * Copyright 2012-2015 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package org.springframework.boot.maven;
+
+import java.net.URLClassLoader;
+import java.util.Arrays;
+import java.util.LinkedList;
+
+import org.apache.maven.plugin.MojoExecutionException;
+import org.apache.maven.plugins.annotations.LifecyclePhase;
+import org.apache.maven.plugins.annotations.Mojo;
+import org.apache.maven.plugins.annotations.ResolutionScope;
+
+/**
+ *
+ * @author Stephane Nicoll
+ */
+@Mojo(name = "start", requiresProject = true, defaultPhase = LifecyclePhase.PRE_INTEGRATION_TEST, requiresDependencyResolution = ResolutionScope.TEST)
+public class StartMojo extends AbstractRunMojo {
+
+	private static final String ENABLE_SHUTDOWN = "--spring.application.lifecycle.enabled=true";
+
+	private final Object lock = new Object();
+
+	protected void runWithForkedJvm(String startClassName) throws MojoExecutionException {
+		throw new UnsupportedOperationException("Fork mode not supported by start goal");
+	}
+
+	protected void runWithMavenJvm(String startClassName, String... arguments) throws MojoExecutionException {
+		IsolatedThreadGroup threadGroup = new IsolatedThreadGroup(startClassName);
+		Thread launchThread = new Thread(threadGroup, new LaunchRunner(startClassName,
+				resolveArguments(arguments)), startClassName + ".main()");
+		launchThread.setContextClassLoader(new URLClassLoader(getClassPathUrls()));
+		launchThread.start();
+
+		// TODO: waaaaaaat?
+		synchronized (this.lock) {
+			try {
+				this.lock.wait(10000);
+			}
+			catch (InterruptedException e) {
+				e.printStackTrace();
+			}
+		}
+	}
+
+	private String[] resolveArguments(String... arguments) {
+		LinkedList<String> args = (arguments != null ?
+				new LinkedList<String>(Arrays.asList(arguments)) : new LinkedList<String>());
+		args.addFirst(ENABLE_SHUTDOWN);
+		return args.toArray(new String[args.size()]);
+	}
+}
diff --git a/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/StopMojo.java b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/StopMojo.java
new file mode 100644
index 00000000000..890ced7423c
--- /dev/null
+++ b/spring-boot-tools/spring-boot-maven-plugin/src/main/java/org/springframework/boot/maven/StopMojo.java
@@ -0,0 +1,62 @@
+/*
+ * Copyright 2012-2015 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package org.springframework.boot.maven;
+
+import java.lang.management.ManagementFactory;
+import javax.management.InstanceNotFoundException;
+import javax.management.MBeanServer;
+import javax.management.MalformedObjectNameException;
+import javax.management.ObjectName;
+
+import org.apache.maven.plugin.AbstractMojo;
+import org.apache.maven.plugin.MojoExecutionException;
+import org.apache.maven.plugin.MojoFailureException;
+import org.apache.maven.plugins.annotations.LifecyclePhase;
+import org.apache.maven.plugins.annotations.Mojo;
+
+/**
+ *
+ * @author Stephane Nicoll
+ */
+@Mojo(name = "stop", requiresProject = true, defaultPhase = LifecyclePhase.POST_INTEGRATION_TEST)
+public class StopMojo extends AbstractMojo {
+
+	//Note: see org.springframework.boot.autoconfigure.test.ApplicationShutdownAutoConfiguration
+	static final String OBJECT_NAME = "org.springframework.boot.test:type=SpringApplicationLifecycle";
+
+	@Override
+	public void execute() throws MojoExecutionException, MojoFailureException {
+		//TODO: support fork?
+		getLog().info("Stopping Spring Boot application.");
+		MBeanServer server = ManagementFactory.getPlatformMBeanServer();
+		try {
+			ObjectName objectName = new ObjectName(OBJECT_NAME);
+			server.invoke(objectName, "shutdown", null, null);
+		}
+		catch (MalformedObjectNameException e) {
+			throw new IllegalStateException("Invalid object name", e);
+		}
+		catch (InstanceNotFoundException e) {
+			throw new MojoFailureException("Application shutdown hook not found. Could not " +
+					"stop application gracefully", e);
+		}
+		catch (Exception e) {
+			throw new MojoExecutionException("Could not stop application", e);
+		}
+
+	}
+}
